/*********************************************

Project : elektronisches Maennchen
Author  : Karsten Mueller
Date    : 27.07.2013

*********************************************/
#define F_CPU 1200000UL //Fuses auf Standard-Einstellung: 9.6 MHz, CKDIV8
#include  <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <avr/interrupt.h>

#include "lieder.h"

// Analog-Digital-Wandler
// 10 Messungen durchfuehren
// Ergebnis zuordnen
char ADCread() 
{
   char i;
   uint16_t result=0;
   for(i=0; i<10; i++)                 
     {                   
       ADCSRA |= (1<<ADSC);             
       while (ADCSRA & (1<<ADSC) ) {}
       result += ADCW;
     }
  if(result<101*10) return 0; 
  if(result<204*10) return reFuss; // 1
  if(result<409*10) return reKnie; // 2
  if(result<700*10) return liFuss; // 3
  if(result<900*10) return liKnie; // 4
  return Becken; // 5
}

void LEDs(char leds) 
{
   switch(leds) 
     {
        case Penis  : DDRB=(1<<SPEAKER)|(1<<PB0)|(1<<PB2); PORTB=(1<<PB2); break; //LED 1
        case rHerz  : DDRB=(1<<SPEAKER)|(1<<PB0)|(1<<PB2); PORTB=(1<<PB0); break; //LED 2
        case liAuge : DDRB=(1<<SPEAKER)|(1<<PB0)|(1<<PB3); PORTB=(1<<PB3); break; //LED 3
        case reAuge : DDRB=(1<<SPEAKER)|(1<<PB0)|(1<<PB3); PORTB=(1<<PB0); break; //LED 4
        case gHerz  : DDRB=(1<<SPEAKER)|(1<<PB2)|(1<<PB3); PORTB=(1<<PB3); break; //LED 5
        case reHand : DDRB=(1<<SPEAKER)|(1<<PB2)|(1<<PB3); PORTB=(1<<PB2); break; //LED 6
    }
}

void warte(char zeit) 
{
   while ( zeit-- )
     _delay_us(2);
}

void main(void)
{
   unsigned char modus = 0;
   unsigned char index=0;
   
   //Ein-/Ausgaenge konfigurieren
   DDRB=(1<<SPEAKER);
   PORTB=0x00;
   
   // Timer/Counter 0 konfigurieren
   // CTC mode, toggle OC0B bei compare match
   // Takt: intern, prescale 8 
   TCCR0A=(1<<WGM01) | (1<<COM0B0);
   TCCR0B=(1<<CS01);
   TON=Silence;
  	
   //ADC konfigurieren
   ADCSRA= (1<<ADEN);
   ADCSRA|= (1<<ADPS1) | (1<<ADPS0);
   ADMUX=2; //PB4
   ADCread();

   while (1)  //Hauptprogramm
     {    
        while ( ADCread() == 0 ) //auf Beruehrung eines Diagnosepunktes warten
          {			
             _delay_ms(200);
             
             if ( modus == reFuss ) //Modus Lauflicht- nutzt delay gleich mit
               {
                  index++;
                  if ( index > 6 ) 
                     index=1;
                  LEDs(index);
                  TON=155-index*20;
                  _delay_ms(20);
                  TON=Silence;
              }
          }
        modus=ADCread();
      
        if ( modus == liKnie ) //Lied abspielen
          { 
             char lang;
             
             for ( index=0; index<lied_laenge; index++)
               { 
                  //Note laden
                  TON  = lied[index][0];
                 /* if ( TON < 45 )        //fuer Frequenzen unter 278 Herz (z.B. C1 und tiefer)
                    TCCR0B |= (1<<CS00);   
                  else
                    TCCR0B &= ~(1<<CS00);*/
                  lang = lied[index][1] * 6;

                  //Laenge der Note abwarten
                  for ( lang; lang; lang-- )
                    _delay_ms(20);
                    
                  TON=Silence;
                  
                  //kurze Pause zwischen Noten
                  LEDs( rHerz );
                  _delay_ms(30);
                  PORTB=0;
               }
          }

        if ( modus == liFuss ) //Wuerfel
          {
             while ( ADCread() > 0 )
               {
                 index++;
                 if ( index > 240 ) 
                   index=1;
                 LEDs( index%6+1 );
               }
             TON=135-(index%6)*20;
             _delay_ms(200);
             TON=Silence;
          }  
   
        if ( modus == reFuss ) //Lauflicht, siehe ADC
          _delay_ms(500);
      
        if ( modus == reKnie ) //Zombie
          {
             _delay_ms(500);
             char up=0;
             index=0;
             char lampe=0;
             
             while( ADCread() == 0 ) //erzeugt mit zwei Dreiecksschwingungen PWM fuer LEDs
               {
                  up++;
                  if ( up == 5 || index == 0 ) //hochzaehlen
                    { 
                      index++;
                      up=0;
                    }
                  if ( up == 15 || index == 150) //runterzaehlen
                    {
                       index--;
                       up=10;
                    }
                  if (lampe < 128 ) //Bit 7->hoch bzw. runterzaehlen, zweite Schwingungs
                    lampe++;
                  else
                    {
                       if ( lampe == 128 )
                         lampe=255;
                       if ( lampe == 129 )
                         lampe=1;
                       lampe--;             
                    }
                  LEDs( reAuge );
                  warte(index);
                  LEDs( liAuge );
                  warte(index);
                  LEDs( reHand );
                  warte( 80 - MAX( index/2 , 25 ) + ( lampe&127 )/4 );
                  PORTB=0;
                  warte(200-index); //kein echtes PWM, da PWM Frequenz nicht gleich
               }  
          }
      
        if ( modus == Becken ) //Herzschlag
          {
          	 index++;
             if ( index == 10 )
               {
                  LEDs( rHerz );
                  TON=255-C2;			
               }
             if ( index > 11 )
               {
                  LEDs( gHerz );
                  index=0;
                  TON=255-C2;
               }
             _delay_ms(40);
             TON=Silence;
          }
     }
}